unit WinOSDControlsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc,DateUtils;

type
  TWinOSDControls = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    OSD_Resolution_Mode: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    OSD_Comp_Voltage_Edit: TEdit;
    OSD_Comp_Voltage: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    OSD_Left_offset_Edit: TEdit;
    OSD_Left_offset: TUpDown;
    Label5: TLabel;
    OSD_Top_lines_offset_Edit: TEdit;
    OSD_Top_lines_offset: TUpDown;
    TabSheet3: TTabSheet;
    Label6: TLabel;
    osd_lang: TComboBox;
    OSD_Show_Horizon: TCheckBox;
    OSD_Show_Altitude: TCheckBox;
    OSD_Show_Ground_Speed: TCheckBox;
    OSD_Show_Course: TCheckBox;
    OSD_Show_Vario: TCheckBox;
    OSD_GPS_Status: TCheckBox;
    OSD_GPS_Latitude: TCheckBox;
    OSD_GPS_Longitude: TCheckBox;
    OSD_RSSI: TCheckBox;
    OSD_Home_Compass: TCheckBox;
    OSD_Home_Distance: TCheckBox;
    OSD_Target_Distance: TCheckBox;
    OSD_Main_Bat_Volt: TCheckBox;
    OSD_Main_Bat_Current: TCheckBox;
    OSD_Main_Bat_Current_Capacity: TCheckBox;
    OSD_Second_Bat_Volt: TCheckBox;
    OSD_Third_Bat_Volt: TCheckBox;
    OSD_Flight_Mode: TCheckBox;
    OSD_Air_Speed: TCheckBox;
    OSD_Debug_Params: TCheckBox;
    OSD_Flight_Time: TCheckBox;
    OSD_Home_Radar: TCheckBox;
    OSD_Show_Outline_Border: TCheckBox;
    OSD_Force_Show: TCheckBox;
    Label7: TLabel;
    RSSI_X_Edit: TEdit;
    RSSI_X: TUpDown;
    RSSI_Y_Edit: TEdit;
    RSSI_Y: TUpDown;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Main_Bat_X_Edit: TEdit;
    Main_Bat_X: TUpDown;
    Main_Bat_Y_Edit: TEdit;
    Main_Bat_Y: TUpDown;
    Label11: TLabel;
    GPS_Status_X_Edit: TEdit;
    GPS_Status_X: TUpDown;
    GPS_Status_Y_Edit: TEdit;
    GPS_Status_Y: TUpDown;
    Label12: TLabel;
    Current_X_Edit: TEdit;
    Current_X: TUpDown;
    Current_Y_Edit: TEdit;
    Current_Y: TUpDown;
    Label13: TLabel;
    Air_Speed_X_Edit: TEdit;
    Air_Speed_X: TUpDown;
    Air_Speed_Y_Edit: TEdit;
    Air_Speed_Y: TUpDown;
    Label14: TLabel;
    Capacity_X_Edit: TEdit;
    Capacity_X: TUpDown;
    Capacity_Y_Edit: TEdit;
    Capacity_Y: TUpDown;
    Label15: TLabel;
    Dist_To_Target_X_Edit: TEdit;
    Dist_To_Target_X: TUpDown;
    Dist_To_Target_Y_Edit: TEdit;
    Dist_To_Target_Y: TUpDown;
    Label16: TLabel;
    Dist_To_Home_X_Edit: TEdit;
    Dist_To_Home_X: TUpDown;
    Dist_To_Home_Y_Edit: TEdit;
    Dist_To_Home_Y: TUpDown;
    Label17: TLabel;
    Home_Indicator_X_Edit: TEdit;
    Home_Indicator_X: TUpDown;
    Home_Indicator_Y_Edit: TEdit;
    Home_Indicator_Y: TUpDown;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Latitude_X_Edit: TEdit;
    Latitude_X: TUpDown;
    Latitude_Y_Edit: TEdit;
    Latitude_Y: TUpDown;
    Label21: TLabel;
    Longitude_X_Edit: TEdit;
    Longitude_X: TUpDown;
    Longitude_Y_Edit: TEdit;
    Longitude_Y: TUpDown;
    Label22: TLabel;
    Variometer_X_Edit: TEdit;
    Variometer_X: TUpDown;
    Variometer_Y_Edit: TEdit;
    Variometer_Y: TUpDown;
    Label23: TLabel;
    Second_Bat_X_Edit: TEdit;
    Second_Bat_X: TUpDown;
    Second_Bat_Y_Edit: TEdit;
    Second_Bat_Y: TUpDown;
    Label24: TLabel;
    Third_Bat_X_Edit: TEdit;
    Third_Bat_X: TUpDown;
    Third_Bat_Y_Edit: TEdit;
    Third_Bat_Y: TUpDown;
    Label25: TLabel;
    Start_Mode_X_Edit: TEdit;
    Start_Mode_X: TUpDown;
    Start_Mode_Y_Edit: TEdit;
    Start_Mode_Y: TUpDown;
    Label26: TLabel;
    Label27: TLabel;
    Adv_Altitude_X_Edit: TEdit;
    Adv_Altitude_X: TUpDown;
    Adv_Altitude_Y_Edit: TEdit;
    Label28: TLabel;
    Adv_Altitude_Y: TUpDown;
    Label29: TLabel;
    Adv_Speed_X_Edit: TEdit;
    Adv_Speed_X: TUpDown;
    Adv_Speed_Y_Edit: TEdit;
    Adv_Speed_Y: TUpDown;
    Label30: TLabel;
    Adv_Compass_X_Edit: TEdit;
    Adv_Compass_X: TUpDown;
    Adv_Compass_Y_Edit: TEdit;
    Adv_Compass_Y: TUpDown;
    Label31: TLabel;
    Adv_Home_Arrow_X_Edit: TEdit;
    Adv_Home_Arrow_X: TUpDown;
    Adv_Home_Arrow_Y_Edit: TEdit;
    Adv_Home_Arrow_Y: TUpDown;
    Label32: TLabel;
    Adv_Home_Icon_X_Edit: TEdit;
    Adv_Home_Icon_X: TUpDown;
    Adv_Home_Icon_Y_Edit: TEdit;
    Adv_Home_Icon_Y: TUpDown;
    Label33: TLabel;
    Adv_Home_Dist_X_Edit: TEdit;
    Adv_Home_Dist_X: TUpDown;
    Adv_Home_Dist_Y_Edit: TEdit;
    Adv_Home_Dist_Y: TUpDown;
    Label34: TLabel;
    Adv_Target_Dist_X_Edit: TEdit;
    Adv_Target_Dist_X: TUpDown;
    Adv_Target_Dist_Y_Edit: TEdit;
    Adv_Target_Dist_Y: TUpDown;
    Label35: TLabel;
    Adv_RSSI_Icon_X_Edit: TEdit;
    Adv_RSSI_Icon_X: TUpDown;
    Adv_RSSI_Icon_Y_Edit: TEdit;
    Adv_RSSI_Icon_Y: TUpDown;
    Label36: TLabel;
    Adv_RSSI_Digit_X_Edit: TEdit;
    Adv_RSSI_Digit_X: TUpDown;
    Adv_RSSI_Digit_Y_Edit: TEdit;
    Adv_RSSI_Digit_Y: TUpDown;
    Label37: TLabel;
    Adv_Main_Bat_X_Edit: TEdit;
    Adv_Main_Bat_X: TUpDown;
    Adv_Main_Bat_Y_Edit: TEdit;
    Adv_Main_Bat_Y: TUpDown;
    Label38: TLabel;
    Adv_Air_Speed_X_Edit: TEdit;
    Adv_Air_Speed_X: TUpDown;
    Adv_Air_Speed_Y_Edit: TEdit;
    Adv_Air_Speed_Y: TUpDown;
    Label39: TLabel;
    Adv_Current_X_Edit: TEdit;
    Adv_Current_X: TUpDown;
    Adv_Current_Y_Edit: TEdit;
    Adv_Current_Y: TUpDown;
    Label40: TLabel;
    Adv_Capacity_X_Edit: TEdit;
    Adv_Capacity_X: TUpDown;
    Adv_Capacity_Y_Edit: TEdit;
    Adv_Capacity_Y: TUpDown;
    Label41: TLabel;
    Adv_Second_Bat_X_Edit: TEdit;
    Adv_Second_Bat_X: TUpDown;
    Adv_Second_Bat_Y_Edit: TEdit;
    Adv_Second_Bat_Y: TUpDown;
    Label42: TLabel;
    Adv_Third_Bat_X_Edit: TEdit;
    Adv_Third_Bat_X: TUpDown;
    Adv_Third_Bat_Y_Edit: TEdit;
    Adv_Third_Bat_Y: TUpDown;
    Label43: TLabel;
    Adv_GPS_State_X_Edit: TEdit;
    Adv_GPS_State_X: TUpDown;
    Adv_GPS_State_Y_Edit: TEdit;
    Adv_GPS_State_Y: TUpDown;
    Label44: TLabel;
    Adv_Latitude_X_Edit: TEdit;
    Adv_Latitude_X: TUpDown;
    Adv_Latitude_Y_Edit: TEdit;
    Adv_Latitude_Y: TUpDown;
    Label45: TLabel;
    Adv_Longitude_X_Edit: TEdit;
    Adv_Longitude_X: TUpDown;
    Adv_Longitude_Y_Edit: TEdit;
    Adv_Longitude_Y: TUpDown;
    Label46: TLabel;
    Adv_FS_Alarm_X_Edit: TEdit;
    Adv_FS_Alarm_X: TUpDown;
    Adv_FS_Alarm_Y_Edit: TEdit;
    Adv_FS_Alarm_Y: TUpDown;
    Label47: TLabel;
    Adv_AP_Flight_Mode_X_Edit: TEdit;
    Adv_AP_Flight_Mode_X: TUpDown;
    Adv_AP_Flight_Mode_Y_Edit: TEdit;
    Adv_AP_Flight_Mode_Y: TUpDown;
    Label48: TLabel;
    Adv_AP_Nav_Mode_X_Edit: TEdit;
    Adv_AP_Nav_Mode_X: TUpDown;
    Adv_AP_Nav_Mode_Y_Edit: TEdit;
    Adv_AP_Nav_Mode_Y: TUpDown;
    Label49: TLabel;
    Adv_AP_Air_State_X_Edit: TEdit;
    Adv_AP_Air_State_X: TUpDown;
    Adv_AP_Air_State_Y_Edit: TEdit;
    Adv_AP_Air_State_Y: TUpDown;
    Label50: TLabel;
    Adv_AP_Air_State_Pict_X_Edit: TEdit;
    Adv_AP_Air_State_Pict_X: TUpDown;
    Adv_AP_Air_State_Pict_Y_Edit: TEdit;
    Adv_AP_Air_State_Pict_Y: TUpDown;
    Label51: TLabel;
    Adv_Log_Time_X_Edit: TEdit;
    Adv_Log_Time_X: TUpDown;
    Adv_Log_Time_Y_Edit: TEdit;
    Adv_Log_Time_Y: TUpDown;
    Label52: TLabel;
    Adv_Dbg_Params_X_Edit: TEdit;
    Adv_Dbg_Params_X: TUpDown;
    Adv_Dbg_Params_Y_Edit: TEdit;
    Adv_Dbg_Params_Y: TUpDown;
    Label53: TLabel;
    Adv_Vario_X_Edit: TEdit;
    Adv_Vario_X: TUpDown;
    Adv_Vario_Y_Edit: TEdit;
    Adv_Vario_Y: TUpDown;
    Label54: TLabel;
    Adv_Flight_Time_X_Edit: TEdit;
    Adv_Flight_Time_X: TUpDown;
    Adv_Flight_Time_Y_Edit: TEdit;
    Adv_Flight_Time_Y: TUpDown;
    Label55: TLabel;
    Adv_Horizon_Type: TComboBox;
    SpeedButton1: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    procedure WaitForOk;
    { Private declarations }
  public
    { Public declarations }
      InitValues: TStringList;
      procedure LoadVariable(k,v: string);
      procedure SetControlValue(tc: TControl; v: string);
      function  GetControlValue(tc: TControl): string;
      function  FindControl(cn: string): TControl; 
      procedure ApplyChanges;
      procedure OpenRightTab;
  end;

var
  WinOSDControls: TWinOSDControls;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinOSDControls.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   Action:=caFree;
end;

procedure TWinOSDControls.FormDestroy(Sender: TObject);
begin
  InitValues.Free;
  WinOSDControls := nil;
end;

procedure TWinOSDControls.FormCreate(Sender: TObject);
var
  s,k,v: string;
begin
  InitValues:= TStringList.Create;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat osd'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else continue;
    end;
  end;

  OpenRightTab;
end;

procedure TWinOSDControls.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  if pos('_xy',k)>0 then begin
    x:=StringReplace(k,'_xy','_x',[]);
    y:=StringReplace(k,'_xy','_y',[]);
    i:=Pos(',',v);
    tc_x:=FindControl(x);
    tc_y:=FindControl(y);
    if (tc_x <> nil) and (tc_y<>nil) and (i>0) then begin
      xv:=Copy(v,1,i-1);
      yv:=Copy(v,i+1,Length(v));
      SetControlValue(tc_x,xv);
      SetControlValue(tc_y,yv);
      InitValues.Values[k]:=v;
    end;
  end else begin
    tc:=FindControl(k);
    if(tc<>nil) then begin
      SetControlValue(tc,v);
      InitValues.Values[k]:=v;
    end;
  end;
end;

procedure TWinOSDControls.ApplyChanges;
var
  i: integer;
  k,v: string;
   tc,tc_x,tc_y: TControl;
   ControlName: string;
   new_v,x,y,new_xv,new_yv: string;
begin
  for i:=0 to InitValues.Count-1 do begin
    k:=InitValues.Names[i];
    v:=InitValues.ValueFromIndex[i];
    if Pos('_xy',k)>0 then begin
      x:=StringReplace(k,'_xy','_x',[]);
      y:=StringReplace(k,'_xy','_y',[]);
      tc_x:=FindControl(x);
      tc_y:=FindControl(y);
      if (tc_x <> nil) and (tc_y<>nil) and (i>0) then begin
        new_xv := GetControlValue(tc_x);
        new_yv := GetControlValue(tc_y);

        new_v:=new_xv+','+new_yv;
        if (new_v<>'') and (new_v <> v) then begin
           MainForm.AddToOutput('set '+k+' '+ new_xv+ ' '+new_yv +#13#10);
           InitValues.Values[k]:=new_v;
        end;
      end;


    end else begin
      tc:=FindControl(k);
      if(tc<>nil) then begin
        new_v:=GetControlValue(tc);
        if (new_v<>'') and (new_v <> v) then begin
           MainForm.AddToOutput('set '+k+' '+ new_v +#13#10);
           InitValues.Values[k]:=new_v;
        end;
      end;
    end;


  end;

  OpenRightTab;

end;

procedure TWinOSDControls.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;

  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;

  if tc.ClassName='TCheckBox' then begin
     if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
  end;

end;

function TWinOSDControls.FindControl(cn: string): TControl;
begin
    Result:=Panel1.FindChildControl(cn);
    if Result = nil then begin
       Result:=TabSheet1.FindChildControl(cn);
       if Result = nil then begin
         Result:=TabSheet2.FindChildControl(cn);
         if Result = nil then begin
            Result:=TabSheet3.FindChildControl(cn);
            if Result = nil then exit;
         end;
       end;
    end;
end;

function TWinOSDControls.GetControlValue(tc: TControl): string;
begin

  Result:='';  
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;

  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;

  if tc.ClassName='TCheckBox' then begin
     Result:='0';
     if (tc as TCheckBox).Checked then Result:='1';
  end;


end;

procedure TWinOSDControls.BitBtn3Click(Sender: TObject);
begin
  ApplyChanges;
end;

procedure TWinOSDControls.OpenRightTab;
begin
  if OSD_Resolution_Mode.ItemIndex = 0 then begin
     TabSheet2.TabVisible:=true;
     TabSheet3.TabVisible:=false;
  end else begin
     TabSheet2.TabVisible:=false;
     TabSheet3.TabVisible:=true;
  end;
end;

procedure TWinOSDControls.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinOSDControls.BitBtn1Click(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;


procedure TWinOSDControls.WaitForOk;
var
   s: string;
   ts: TDateTime;
begin
   ts:=now;
      while true do begin
        if MilliSecondsBetween(Now,ts) > 1000 then break;
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
        end;
      end;

end;

procedure TWinOSDControls.SpeedButton1Click(Sender: TObject);
begin
    MainForm.AddToOutput('reset osd'+#13#10);
    WaitForOk;
    FormCreate(Sender);
end;

end.
